// ball-splatting geom. shader

#version 120 
#extension GL_EXT_geometry_shader4 : enable

void main(void)
{
    //Ball radius is mapped as z-color component (max 1.0);
    float r = gl_FrontColorIn[0].z;

    //get one point as input
    //generate one triangle strip (made of two triangles) representing one quad

    gl_Position = gl_PositionIn[0]; //eye-space position
    gl_Position.x -= r;
    gl_Position.y -= r;
    gl_Position = gl_ProjectionMatrix * gl_Position;
    gl_TexCoord[0].xy = vec2(0, 0);
    gl_FrontColor = gl_FrontColorIn[0];
    EmitVertex();

    gl_Position = gl_PositionIn[0];
    gl_Position.x -= r;
    gl_Position.y += r;
    gl_Position = gl_ProjectionMatrix * gl_Position;
    gl_TexCoord[0].xy = vec2(0, 1);
    gl_FrontColor = gl_FrontColorIn[0];
    EmitVertex();

    gl_Position = gl_PositionIn[0];
    gl_Position.x += r;
    gl_Position.y -= r;
    gl_Position = gl_ProjectionMatrix * gl_Position;
    gl_TexCoord[0].xy = vec2(1, 0);
    gl_FrontColor = gl_FrontColorIn[0];
    EmitVertex();

    gl_Position = gl_PositionIn[0];
    gl_Position.x += r;
    gl_Position.y += r;
    gl_Position = gl_ProjectionMatrix * gl_Position;
    gl_TexCoord[0].xy = vec2(1, 1);
    gl_FrontColor = gl_FrontColorIn[0];
    EmitVertex();		

    EndPrimitive();	
		
}

